#ifndef FRAME_H
#define FRAME_H

#include <string>
#include "PNGwrite.h"
#ifdef OSMESA
#include <GL/osmesa.h>
#endif

class TBmeshWin;

class  Frame {
    public:
      Frame( TBmeshWin *t );
      ~Frame();
      Frame( TBmeshWin *t, int, int, string );
      Frame( TBmeshWin *t, int, int, bool=false );
      int write( int, int, string, int );
      int write( int, int,  string, int, int,int stride=1 );
      void dump( int, int,  string );
      void pixel_color( int x, int y, GLubyte *color ){
                     memcpy( color, _buffer+(x+_w*y)*4, 4*sizeof(GLubyte ) );}
    private:
     GLubyte* _buffer = NULL;
     int  _w;
     int  _h;
     bool _full_alpha=false;
     TBmeshWin *_tbwm;
     void delete_objs();
#ifdef OSMESA
     OSMesaContext	_ctx;
#else
     GLuint _fb, _color_rb, _depth_rb;
#endif
     void fill_buffer( int w, int h, bool alpha=false );
};

#include "TBmeshWin.h"
#endif
